<?php

function greencode_tag_cloud() {
	global $wpdb, $wp_query;
	
	$query = "SELECT * FROM ".$wpdb->categories." WHERE category_count > 0 ORDER BY cat_name ASC";
	$categories = $wpdb->get_results($query);
	
	$file = get_settings('home') . '/';
	
	$num_found = 0;
	$total_posts = 0;
	$most_posts = 0;
	
	foreach ($categories as $c){
		$total_posts += $c->category_count;
		$most_posts = max($c->category_count, $most_posts);
	}
	
	$minimum_font_size = 8;
	$maximum_font_size = 42;
	
	$cloud = '<span class="tag-cloud">';
	
	foreach ($categories as $c){
		$modifier = ($c->category_count / (($total_posts + $most_posts) / 2));
		$opacity = (($c->category_count / $most_posts) * 0.45) + 0.55;
		
		$link = '<a href="'.get_category_link($c->cat_ID).'" ';
		$link .= 'title="'. sprintf(__("View all posts (%d) tagged with %s"), $c->category_count, wp_specialchars($c->cat_name)) . '"';
		$link .= ' style="font-size: '.round($minimum_font_size + ($modifier * $maximum_font_size)) .'px; opacity: '.round($opacity, 2).';">';
		$link .= apply_filters('list_cats', $c->cat_name, $c).'</a> ';
		
		$cloud .= $link;
	}
	
	$cloud .= '</span>';
	
	echo $cloud;
}

?>